//=============================================================================
// ASC Ath Server Controller
// Version 7
// October 2004
// By 'ATHoS' Mickal DEHEZ && Cedric MEGNAT
//=============================================================================
//=============================================================================
// ascRPW.
//=============================================================================
class ascRPW expands UWindowPageWindow;

var UWindowSmallButton SetBootB,AddMutB,CrashB,ResetMutB;
var UWindowComboControl GameTypeS,MutatorS;
var UWindowCheckbox BootC,MutatorC;
var UWindowMessageBoxArea CurrentURL,AddedMut;
var String MutatorChain;
function Created(){
	local int line;
	Super.Created();
	line=0;
	UWindowMessageBoxArea(CreateWindow(class'UWindowMessageBoxArea', 20, line+1, WinWidth-40, 16))
	.Message = "Boot Controller";
	line=20;
	BootC = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, line, 550, 1));
	BootC.SetText("Boot the server with ASC : It changes the booting map each time and enables those following GameType/Mutators :");
	BootC.Align = TA_Right;
	line=40;
	GameTypeS = UWindowComboControl(CreateControl(class'UWindowComboControl', 20, line, 360, 1));
	GameTypeS.EditBoxWidth=180;
	GameTypeS.SetText("Select a GameType :");
	GameTypeS.SetEditable(False);
	line=60;
	MutatorS = UWindowComboControl(CreateControl(class'UWindowComboControl', 20, line, 360, 1));
	MutatorS.EditBoxWidth=180;
	MutatorS.SetText("Select a Mutator :");
	MutatorS.SetEditable(False);
	AddMutB	= UWindowSmallButton(CreateControl(class'UWindowSmallButton', 400, line, 80, 16));
	AddMutB.SetText("ADD");
	ResetMutB = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 500, line, 80, 16));
	ResetMutB.SetText("RESET");
	line=80;
	AddedMut=UWindowMessageBoxArea(CreateWindow(class'UWindowMessageBoxArea', 20, line+4, WinWidth-40, 40));
	line=120;
	MutatorC = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 20, line, 410, 1));
	MutatorC.SetText("Force Mutators, the server won't stay without mutator (it prevents from major crash).");
	MutatorC.Align = TA_Right;	
	line=140;
	UWindowMessageBoxArea(CreateWindow(class'UWindowMessageBoxArea', 60, line, WinWidth-60, 16))
	.Message = "Please make sure you have all serverpackages and maps needed to run those mutators and gametype.";
	line=160;
	SetBootB = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 150, line, 300, 16));
	SetBootB.SetText("Update and Save");
	line=180;
	line=200;
	CrashB = UWindowSmallButton(CreateControl(class'UWindowSmallButton', 150, line, 300, 16));
	CrashB.SetText("Reboot the server / Try out the ASC booting");
}
function Notify(UWindowDialogControl C, byte E)
{
		local int i;
		Super.Notify(C, E);
        switch(E)
        {
        case DE_Click:
                switch (C){
				case SetBootB:
					if(BootC.bChecked){
						if(GameTypeS.GetValue2()!="")
							getplayerowner().ConsoleCommand("mutate asc#set#boot#gametype#"$GameTypeS.GetValue2());
						getplayerowner().ConsoleCommand("mutate asc#set#boot#mutators#"$MutatorChain);
						getplayerowner().ConsoleCommand("mutate asc#set#boot#forcemutator#"$MutatorC.bChecked);
					}
					getplayerowner().ConsoleCommand("mutate asc#set#boot#enabled#"$BootC.bChecked);
 				break;
				case CrashB:
					getplayerowner().ConsoleCommand("mutate asc#set#reboot");
 				break;
				case AddMutB:
					if( InStr(MutatorChain,MutatorS.GetValue2()) == -1 ){
						if(MutatorChain==""){
							MutatorChain=MutatorS.GetValue2();
							AddedMut.Message=MutatorS.GetValue2();
						}
						else{
							MutatorChain=MutatorChain$","$MutatorS.GetValue2();
							AddedMut.Message=AddedMut.Message$", "$MutatorS.GetValue2();
						}
					}
					
 				break;
				case ResetMutB:
					MutatorChain="";
					AddedMut.Message="-";
 				break;
              }
		}
}
function Paint(Canvas C, float X, float Y)
{
        local Texture T;
        Super.Paint(C, X, Y);
        T = GetLookAndFeelTexture();
        DrawUpBevel( C, 0, 0, WinWidth, 14, T);
	    DrawUpBevel( C, 16, 80, WinWidth-32, 32, T);
	    DrawUpBevel( C, 0, 180, WinWidth, 14, T);
}
function Close(optional bool bByParent)
{
		WindowConsole(GetPlayerOwner().Player.Console).CloseUWindow();
        Super.Close(bByParent);
}

defaultproperties
{
}
